-- Author      : Scott
-- Create Date : 10/3/2017 5:38:25 PM

ItemDrop_variablesLoaded = false
ItemDropRealm = GetRealmName()
ItemDropChar = UnitName("player")
ItemDrop_details = {
    name = "ItemDrop",
    frame="Frame1",
    optionsFrame = "Frame1"
}
local frame = CreateFrame("FRAME", "ItemDrop")

--Default Config
local ItemDrop_Config_defaultOn = true
local ItemDrop_Config_defaultRare = false
local ItemDrop_Config_defaultEpic = true
local ItemDrop_Config_defaultLegendary = true

local audioPath = "Interface\\Addons\\ItemDrop\\itemdrop_"
local colorDef = {
    "ff0070dd",
    "ffa335ee",
    "ffff8000"
}
local qualityDef = {
    "rare",
    "epic",
    "legendary"
}

function Frame1_OnLoad()
	Frame1:RegisterEvent("ADDON_LOADED")
	Frame1:SetScript("OnEvent", Frame1_OnEvent)
end

function Frame1_OnEvent(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "ItemDrop" then
		ItemDrop_VARIABLES_LOADED()
	end
end

SLASH_ITEMDROP1 = "/itemdrop"
SlashCmdList["ITEMDROP"] = function(msg)
    Frame1:Show()
end 

function ItemDrop_VARIABLES_LOADED()
    if (not ItemDrop_Config) then
        ItemDrop_Config = {}
	end
    if (not ItemDrop_Config[ItemDropRealm]) then
        ItemDrop_Config[ItemDropRealm] = {}
    end
    if not ItemDrop_Config[ItemDropRealm][ItemDropChar] then
        ItemDrop_Config[ItemDropRealm][ItemDropChar] = {}
    end
    if ItemDrop_Config[ItemDropRealm][ItemDropChar]["on"] == nil then
        ItemDrop_Config[ItemDropRealm][ItemDropChar]["on"] = ItemDrop_Config_defaultOn
    end
    if ItemDrop_Config[ItemDropRealm][ItemDropChar]["rare"] == nil then
        ItemDrop_Config[ItemDropRealm][ItemDropChar]["rare"] = ItemDrop_Config_defaultRare
    end
    if ItemDrop_Config[ItemDropRealm][ItemDropChar]["epic"] == nil then
        ItemDrop_Config[ItemDropRealm][ItemDropChar]["epic"] = ItemDrop_Config_defaultEpic
    end
    if ItemDrop_Config[ItemDropRealm][ItemDropChar]["legendary"] == nil then
        ItemDrop_Config[ItemDropRealm][ItemDropChar]["legendary"] = ItemDrop_Config_defaultLegendary
    end
    ItemDrop_variablesLoaded = true
    if(myAddOnsFrame_Register) then 
        myAddonsFrame_Register(ItemDrop_details)
    end
	Frame1:UnregisterAllEvents()
	ItemDrop_Config_Update()
end

function ItemDrop_Config_Update()
	if not ItemDrop_Config then
		return
	end
	CheckButtonRare:SetChecked(ItemDrop_Config[ItemDropRealm][ItemDropChar]["rare"])
	CheckButtonEpic:SetChecked(ItemDrop_Config[ItemDropRealm][ItemDropChar]["epic"])
	CheckButtonLegendary:SetChecked(ItemDrop_Config[ItemDropRealm][ItemDropChar]["legendary"])
end

function ItemDrop_Config_Defaults()
    if not ItemDrop_variablesLoaded then
        return
    end
    ItemDrop_Config[ItemDropRealm][ItemDropChar]["rare"] = ItemDrop_Config_defaultRare
    ItemDrop_Config[ItemDropRealm][ItemDropChar]["rare"] = ItemDrop_Config_defaultEpic
    ItemDrop_Config[ItemDropRealm][ItemDropChar]["legendary"] = ItemDrop_Config_defaultLegendary
	ItemDrop_Config_Update()
end

function onEventFire(self, event, msg, _, _, _, target, _, _, _, _, _, _)
    if target == GetUnitName("player") then
        local playString = msg
        playString = string.sub(playString, 21, 28)
        for id, color in ipairs(colorDef) do
            if color == playString and ItemDrop_Config[ItemDropRealm][ItemDropChar][qualityDef[id]] then
                PlaySoundFile(audioPath .. qualityDef[id] .. ".ogg", "master")
			end
        end--]]
    end
end

frame:RegisterEvent("CHAT_MSG_LOOT")
frame:SetScript("OnEvent", onEventFire)

function CheckButtonRare_OnClick(self)
	ItemDrop_Config[ItemDropRealm][ItemDropChar]["rare"] = not ItemDrop_Config[ItemDropRealm][ItemDropChar]["rare"]
	CheckButtonRare:SetChecked(ItemDrop_Config[ItemDropRealm][ItemDropChar]["rare"])
end

function CheckButtonEpic_OnClick()
	ItemDrop_Config[ItemDropRealm][ItemDropChar]["epic"] = not ItemDrop_Config[ItemDropRealm][ItemDropChar]["epic"]
	CheckButtonEpic:SetChecked(ItemDrop_Config[ItemDropRealm][ItemDropChar]["epic"])
end

function CheckButtonLegendary_OnClick()
	ItemDrop_Config[ItemDropRealm][ItemDropChar]["legendary"] = not ItemDrop_Config[ItemDropRealm][ItemDropChar]["legendary"]
	CheckButtonLegendary:SetChecked(ItemDrop_Config[ItemDropRealm][ItemDropChar]["legendary"])
end

function ButtonClose_OnClick()
	Frame1:Hide()
	ItemDrop_Config_Update()
end

function ButtonReset_OnClick()
	ItemDrop_Config_Defaults()
end

function CheckButtonRare_OnLoad()
end

function CheckButtonEpic_OnLoad()
end

function CheckButtonLegendary_OnLoad()
end
